apps/accounts/urls.py
from django.urls import path

from . import views

app_name = 'accounts'

urlpatterns = [
    path('novo-usuario/', views.add_user, name='add_user'),
    path('login/', views.user_login, name='user_login'),
    path('sair/', views.user_logout, name='user_logout'),
    path('alterar-senha/', views.user_change_password, name='user_change_password'),
    path('meu-perfil/', views.list_user_profile, name='list_user_profile'),
    path('novo-perfil/', views.add_user_profile, name='add_user_profile'),
    path('alterar-perfil/<username>/', views.change_user_profile, name='change_user_profile'),
    path('alterar-usuario/<username>/', views.change_user_information, name='change_user_information'),
]

todoapp/urls.py
from django.contrib import admin
from django.urls import path, include
from django.conf import settings
from django.conf.urls.static import static


urlpatterns = [
    path('admin/', admin.site.urls),
    path('tarefas/', include('tasks.urls', namespace='tasks')),
    path('contas/', include('accounts.urls', namespace='accounts')),
    path('', include('core.urls', namespace='core')),
]

urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)
# urlpatterns += static(settings.STATIC_URL, document_root=settings.STATIC_ROOT)

apps/accounts/models.py
from django.db import models
from django.core.exceptions import ValidationError

from django.contrib.auth.models import User

# Create your models here.

class UserProfile(models.Model):
    photo = models.ImageField('Foto', upload_to='photos')
    cell_phone = models.CharField('Celular', max_length=16)
    user = models.OneToOneField(User, on_delete=models.CASCADE, related_name='profile')

    class Meta:
        verbose_name = 'Perfil do usuário'
        verbose_name_plural = 'Perfis dos usuários'
    
    def __str__(self):
        return self.user.username
    
    def clean(self):
        model = self.__class__
        if model.objects.count() > 0 and self.id != model.objects.get().id:
            raise ValidationError("Você já tem um perfil cadastrado.")

apps/accounts/forms.py
from django import forms
from django.contrib.auth.models import User

from .models import UserProfile

class UserForm(forms.ModelForm):
    class Meta:
        model = User
        fields = ['first_name', 'last_name', 'username', 'password', 'email']

class UserFormChangeInformation(forms.ModelForm):
    class Meta:
        model = User
        fields = ['first_name', 'last_name', 'email']


class UserProfileForm(forms.ModelForm):
    class Meta:
        model = UserProfile
        exclude = ['user']

apps/accounts/views.py
from django.shortcuts import render, redirect
from django.contrib.auth.models import User
from django.contrib import messages
from django.contrib.auth import authenticate, login, logout, update_session_auth_hash
from django.contrib.auth.decorators import login_required
from django.contrib.auth.forms import PasswordChangeForm

from .forms import UserForm, UserProfileForm, UserFormChangeInformation
from .models import UserProfile

# Create your views here.

def add_user(request):
    template_name = 'accounts/add_user.html'
    context = {}
    if request.method == 'POST':
        form = UserForm(request.POST)
        if form.is_valid():
            f = form.save(commit=False)
            f.set_password(f.password)
            f.save()
            messages.success(request, "Usuário salvo com sucesso!")
    form = UserForm()
    context['form'] = form
    return render(request, template_name, context)

def user_login(request):
    template_name = 'accounts/user_login.html'
    if request.method == 'POST':
        username = request.POST.get('username')
        password = request.POST.get('password')
        user = authenticate(username=username, password=password)
        if user is not None:
            login(request, user)
            return redirect(request.GET.get('next', '/'))
        else:
            messages.error(request, "Usuário ou senha inválidos.")
    return render(request, template_name, {})

@login_required(login_url='/contas/login/')
def user_logout(request):
    logout(request)
    return redirect('accounts:user_login')

@login_required(login_url='/contas/login/')
def user_change_password(request):
    template_name = 'accounts/user_change_password.html'
    context = {}
    if request.method == 'POST':
        form = PasswordChangeForm(user=request.user, data=request.POST)
        if form.is_valid():
            form.save()
            messages.success(request, "Senha alterada com sucesso!")
            update_session_auth_hash(request, form.user)
        else:
            messages.error(request, "Não foi possível trocar sua senha!")
    form = PasswordChangeForm(user=request.user)
    context['form'] = form
    return render(request, template_name, context)

@login_required(login_url='/contas/login/')
def add_user_profile(request):
    template_name = 'accounts/add_user_profile.html'
    context = {}
    if request.method == 'POST':
        form = UserProfileForm(request.POST, request.FILES)
        if form.is_valid():
            f = form.save(commit=False)
            f.user = request.user
            f.save()
            messages.success(request, "Perfil alterado com sucesso!")
    form = UserProfileForm()
    context['form'] = form
    return render(request, template_name, context)

@login_required(login_url='/contas/login/')
def list_user_profile(request):
    template_name = 'accounts/list_user_profile.html'
    try:
        profile = UserProfile.objects.get(user=request.user)
    except UserProfile.DoesNotExist:
        profile = None

    context = {
        'profile': profile
    }
    return render(request, template_name, context)

@login_required(login_url='/contas/login/')
def change_user_profile(request, username):
    template_name = 'accounts/add_user_profile.html'
    context = {}
    profile = UserProfile.objects.get(user__username=username)
    if request.method == 'POST':
        form = UserProfileForm(request.POST, request.FILES, instance=profile)
        if form.is_valid():
            form.save()
            messages.success(request, "Perfil atualizado com sucesso.")
    form = UserProfileForm(instance=profile)
    context['form'] = form
    return render(request, template_name, context)

@login_required(login_url='/contas/login/')
def change_user_information(request, username):
    template_name = 'accounts/change_user_information.html'
    context = {}
    user = User.objects.get(username=username)
    if request.method == 'POST':
        form = UserFormChangeInformation(request.POST, instance=user)
        if form.is_valid():
            form.save()
            messages.success(request, "Informações atualizadas com sucesso.")
    form = UserFormChangeInformation(instance=user)
    context['form'] = form
    return render(request, template_name, context)

templates/accounts/add_user.html
{% extends 'base.html' %}

{% load widget_tweaks %}

{% block title %}
    Novo usuário - {{ block.super }}
{% endblock title %}


{% block body %}
    
    <div class="container">
        <div class="row">
            <div class="col-md-12">
            <h1>Novo Usuário</h1>
            {% include 'partials/messages.html' %}
                <form method='POST' action="." autocomplete="off">
                {% csrf_token %}
                    <div class="form-group">
                        <label for="{{ form.first_name.id_for_label }}">Primeiro nome</label>
                        {{ form.first_name|add_class:"form-control"|attr:"autofocus" }}
                    </div>
                    <div class="form-group">
                        <label for="{{ form.last_name.id_for_label }}">Sobrenome</label>
                        {{ form.last_name|add_class:"form-control" }}
                    </div>
                    <div class="form-group">
                        <label for="{{ form.username.id_for_label }}">Nome de usuário</label>
                        {{ form.username|add_class:"form-control" }}
                    </div>
                    <div class="form-group">
                        <label for="{{ form.email.id_for_label }}">E-mail</label>
                        {{ form.email|add_class:"form-control" }}
                    </div>
                    <div class="form-group">
                        <label for="{{ form.password.id_for_label }}">Senha</label>
                        {{ form.password|add_class:"form-control"|attr:"type:password" }}
                    </div>
                    <button type="submit" class="btn btn-primary">Salvar</button>
                </form>
            </div>
        </div>
    </div>


{% endblock body %}
    

templates/accounts/add_user_profile.html
{% extends 'base.html' %}

{% load widget_tweaks %}

{% block title %}
    Alterar Perfil - {{ block.super }}
{% endblock title %}


{% block body %}
    
    <div class="container">
        <div class="row">
            <div class="col-md-12">
            <h1>Alterar Perfil</h1>
            {% include 'partials/messages.html' %}
                <form method="POST" action="." enctype="multipart/form-data" autocomplete="off">
                {% csrf_token %}
                    <div class="form-group">
                        <label for="{{ form.photo.id_for_label }}">Foto do Perfil</label>
                        {{ form.photo|add_class:"form-control-file" }}
                    </div>
                    <div class="form-group">
                        <label for="{{ form.cell_phone.id_for_label }}">Celular</label>
                        {{ form.cell_phone|add_class:"form-control" }}
                    </div>
                    <button type="submit" class="btn btn-primary">Salvar</button>
                </form>
            </div>
        </div>
    </div>

{% endblock body %}
    
    

templates/accounts/change_user_information.html
{% extends 'base.html' %}

{% load widget_tweaks %}

{% block title %}
    Novo usuário - {{ block.super }}
{% endblock title %}


{% block body %}
    
    <div class="container">
        <div class="row">
            <div class="col-md-12">
            <h1>Alterar Usuário</h1>
            {% include 'partials/messages.html' %}
                <form method='POST' action="." autocomplete="off">
                {% csrf_token %}
                    <div class="form-group">
                        <label for="{{ form.first_name.id_for_label }}">Primeiro nome</label>
                        {{ form.first_name|add_class:"form-control"|attr:"autofocus" }}
                    </div>
                    <div class="form-group">
                        <label for="{{ form.last_name.id_for_label }}">Sobrenome</label>
                        {{ form.last_name|add_class:"form-control" }}
                    </div>
                    <div class="form-group">
                        <label for="{{ form.email.id_for_label }}">E-mail</label>
                        {{ form.email|add_class:"form-control" }}
                    </div>
                    <button type="submit" class="btn btn-primary">Salvar</button>
                </form>
            </div>
        </div>
    </div>


{% endblock body %}
    

templates/accounts/list_user_profile.html
{% extends 'base.html' %}

{% load staticfiles %}

{% load widget_tweaks %}


{% block title %}
    Meu Perfil - {{ block.super }}
{% endblock title %}


{% block body %}
    <div class="container">
        <div class="row">
            <div class="col-md-12">
            <h1>Meu Perfil</h1>
            
            {% if profile %}
                <div class="media">
                    <img src="{{ profile.photo.url }}" class="align-self-start mr-3 rounded-circle" alt="..." width="100" height="100">
                    <div class="media-body">
                        <h5 class="mt-0">{{ profile.user.get_full_name }}</h5>
                        <p>Celular: {{ profile.cell_phone }}</p>
                        <p>E-mail: {{ profile.user.email }}</p>
                    </div>
                </div>
                <a href="{% url 'accounts:change_user_profile' user.username %}" class="btn btn-primary">Alterar Perfil</a>
            {% else %}
                <h2>Você ainda não criou um perfil.</h2>
                <a href="{% url 'accounts:add_user_profile' %}" class="btn btn-primary">Criar Perfil</a>
            {% endif %}
            </div>
        </div>
    </div>
{% endblock body %}
    

templates/accounts/user_change_password.html
{% extends 'base.html' %}

{% load widget_tweaks %}


{% block title %}
    Trocar senha - {{ block.super }}
{% endblock title %}


{% block body %}
    

    <div class="container">

        <div class="row">
            <div class="col-md-12">
                <h1>Alterar Senha</h1>
                {% include 'partials/messages.html' %}
                <form method='POST' action='.' autocomplete="off">
                {% csrf_token %}
                    <div class="form-group">
                        <label for="{{ form.old_password.id_for_label }}">Senha anterior</label>
                        {{ form.old_password|add_class:"form-control"|attr:"type:password" }}
                    </div>
                    <div class="form-group">
                        <label for="{{ form.new_password1.id_for_label }}">Nova senha</label>
                        {{ form.new_password1|add_class:"form-control"|attr:"type:password" }}
                    </div>
                    <div class="form-group">
                        <label for="{{ form.new_password2.id_for_label }}">Confirmar nova senha</label>
                        {{ form.new_password2|add_class:"form-control"|attr:"type:password" }}
                    </div>
                    <button type="submit" class="btn btn-primary">Atualizar</button>
                </form>

            </div>
        </div>

    </div>

{% endblock body %}
    
    

templates/accounts/user_login.html
{% load staticfiles %}
<!doctype html>
<html lang="en">
  <head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
    <meta name="description" content="">
    <title>TodoApp Login</title>

    <!-- Bootstrap core CSS -->
    <link href="{% static 'css/bootstrap.min.css' %}" rel="stylesheet">


    <style>
      .bd-placeholder-img {
        font-size: 1.125rem;
        text-anchor: middle;
        -webkit-user-select: none;
        -moz-user-select: none;
        -ms-user-select: none;
        user-select: none;
      }

      @media (min-width: 768px) {
        .bd-placeholder-img-lg {
          font-size: 3.5rem;
        }
      }
    </style>
    <!-- Custom styles for this template -->
    <link href="{% static 'css/signin.css' %}" rel="stylesheet">
  </head>
  <body class="text-center">
    <form class="form-signin" method="POST" action="." autocomplete="off">
    {% csrf_token %}
        <h1 class="h3 mb-3 font-weight-normal">Identifique-se</h1>
        <label for="username" class="sr-only">Usuário</label>
        <input type="text" id="username" name="username" class="form-control" placeholder="Nome de usuário" required autofocus>
        <label for="password" class="sr-only">Senha</label>
        <input type="password" id="password" name="password" class="form-control" placeholder="Digite sua senha" required>
        <button class="btn btn-lg btn-primary btn-block" type="submit">Entrar</button>
        <a href="{% url 'accounts:add_user' %}" class="btn btn-lg btn-info btn-block" type="submit">Criar conta</a>
    </form>
</body>
</html>